
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class RoutesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const routes = await db.routes.create(
            {
                id: data.id || undefined,
        
        route_name: data.route_name
        ||
        null
            ,
            
        route_code: data.route_code
        ||
        null
            ,
            
        route_status: data.route_status
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return routes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const routesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                route_name: item.route_name
            ||
            null
            ,
            
                route_code: item.route_code
            ||
            null
            ,
            
                route_status: item.route_status
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const routes = await db.routes.bulkCreate(routesData, { transaction });

        // For each item created, replace relation files
        

        return routes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const routes = await db.routes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.route_name !== undefined) updatePayload.route_name = data.route_name;
        
        
        if (data.route_code !== undefined) updatePayload.route_code = data.route_code;
        
        
        if (data.route_status !== undefined) updatePayload.route_status = data.route_status;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await routes.update(updatePayload, {transaction});

        
        

        
        

        

        return routes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const routes = await db.routes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of routes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of routes) {
                await record.destroy({transaction});
            }
        });


        return routes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const routes = await db.routes.findByPk(id, options);

        await routes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await routes.destroy({
            transaction
        });

        return routes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const routes = await db.routes.findOne(
            { where },
            { transaction },
        );

        if (!routes) {
            return routes;
        }

        const output = routes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.operations_route = await routes.getOperations_route({
            transaction
        });
        
        
        
        
        
        
        output.work_orders_route = await routes.getWork_orders_route({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.route_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'routes',
                        'route_name',
                        filter.route_name,
                    ),
                };
            }
            
            if (filter.route_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'routes',
                        'route_code',
                        filter.route_code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'routes',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.route_status) {
                where = {
                    ...where,
                route_status: filter.route_status,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.routes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'routes',
                        'route_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.routes.findAll({
            attributes: [ 'id', 'route_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['route_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.route_name,
        }));
    }

    
};

